



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Python实现CART(基尼指数)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Python实现CART(基尼指数)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-10 07:12:13 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>Python实现CART(基尼指数)</h1>
<h2>运行环境</h2>
<ul><li>Pyhton3</li>
<li>treePlotter模块(画图所需，不画图可不必)</li>
<li>matplotlib(如果使用上面的模块必须)</li></ul>
<h2>计算过程</h2>
<pre class="prettyprint linenums"><code>st=&gt;start: 开始<br />
e=&gt;end<br />
op1=&gt;operation: 读入数据<br />
op2=&gt;operation: 格式化数据<br />
cond=&gt;condition: 是否建树完成<br />
su=&gt;subroutine: 递归建树<br />
op3=&gt;operation: 选择基尼指数最小的为判决点<br />
op4=&gt;operation: 测试判决情况<br />
op5=&gt;operation: 划分为判决节点子树

st-&gt;op1-&gt;op2-&gt;cond<br />
cond(no)-&gt;su-&gt;op5-&gt;op3-&gt;su<br />
cond(yes)-&gt;op4-&gt;e<br />
</code></pre>
<h2>输入样例</h2>
<pre class="prettyprint linenums"><code>/* Dataset.txt */<br />
训练集:

    outlook    temperature    humidity    windy<br />
    ---------------------------------------------------------<br />
    sunny       hot            high         false         N<br />
    sunny       hot            high         true          N<br />
    overcast    hot            high         false         Y<br />
    rain        mild           high         false         Y<br />
    rain        cool           normal       false         Y<br />
    rain        cool           normal       true          N<br />
    overcast    cool           normal       true          Y

测试集<br />
    outlook    temperature    humidity    windy<br />
    ---------------------------------------------------------<br />
    sunny       mild           high         false<br />
    sunny       cool           normal       false<br />
    rain        mild           normal       false<br />
    sunny       mild           normal       true<br />
    overcast    mild           high         true<br />
    overcast    hot            normal       false<br />
    rain        mild           high         true<br />
</code></pre>
<h2>代码实现</h2>
<pre class="prettyprint linenums"><code># -*- coding: utf-8 -*-<br />
__author__ = 'Wsine'

from math import log<br />
import operator<br />
import treePlotter

def calcShannonEnt(dataSet):<br />
	&quot;&quot;&quot;<br />
	输入：数据集<br />
	输出：数据集的香农熵<br />
	描述：计算给定数据集的香农熵<br />
	&quot;&quot;&quot;<br />
	numEntries = len(dataSet)<br />
	labelCounts = {}<br />
	for featVec in dataSet:<br />
		currentLabel = featVec[-1]<br />
		if currentLabel not in labelCounts.keys():<br />
			labelCounts[currentLabel] = 0<br />
		labelCounts[currentLabel] += 1<br />
	shannonEnt = 0.0<br />
	for key in labelCounts:<br />
		prob = float(labelCounts[key])/numEntries<br />
		shannonEnt -= prob * log(prob, 2)<br />
	return shannonEnt

def splitDataSet(dataSet, axis, value):<br />
	&quot;&quot;&quot;<br />
	输入：数据集，选择维度，选择值<br />
	输出：划分数据集<br />
	描述：按照给定特征划分数据集；去除选择维度中等于选择值的项<br />
	&quot;&quot;&quot;<br />
	retDataSet = []<br />
	for featVec in dataSet:<br />
		if featVec[axis] == value:<br />
			reduceFeatVec = featVec[:axis]<br />
			reduceFeatVec.extend(featVec[axis+1:])<br />
			retDataSet.append(reduceFeatVec)<br />
	return retDataSet

def chooseBestFeatureToSplit(dataSet):<br />
	&quot;&quot;&quot;<br />
	输入：数据集<br />
	输出：最好的划分维度<br />
	描述：选择最好的数据集划分维度<br />
	&quot;&quot;&quot;<br />
	numFeatures = len(dataSet[0]) - 1<br />
	bestGini = 999999.0<br />
	bestFeature = -1<br />
	for i in range(numFeatures):<br />
		featList = [example[i] for example in dataSet]<br />
		uniqueVals = set(featList)<br />
		gini = 0.0<br />
		for value in uniqueVals:<br />
			subDataSet = splitDataSet(dataSet, i, value)<br />
			prob = len(subDataSet)/float(len(dataSet))<br />
			subProb = len(splitDataSet(subDataSet, -1, 'N')) / float(len(subDataSet))<br />
			gini += prob * (1.0 - pow(subProb, 2) - pow(1 - subProb, 2))<br />
		if (gini &lt; bestGini):<br />
			bestGini = gini<br />
			bestFeature = i<br />
	return bestFeature

def majorityCnt(classList):<br />
	&quot;&quot;&quot;<br />
	输入：分类类别列表<br />
	输出：子节点的分类<br />
	描述：数据集已经处理了所有属性，但是类标签依然不是唯一的，<br />
		  采用多数判决的方法决定该子节点的分类<br />
	&quot;&quot;&quot;<br />
	classCount = {}<br />
	for vote in classList:<br />
		if vote not in classCount.keys():<br />
			classCount[vote] = 0<br />
		classCount[vote] += 1<br />
	sortedClassCount = sorted(classCount.iteritems(), key=operator.itemgetter(1), reversed=True)<br />
	return sortedClassCount[0][0]

def createTree(dataSet, labels):<br />
	&quot;&quot;&quot;<br />
	输入：数据集，特征标签<br />
	输出：决策树<br />
	描述：递归构建决策树，利用上述的函数<br />
	&quot;&quot;&quot;<br />
	classList = [example[-1] for example in dataSet]<br />
	if classList.count(classList[0]) == len(classList):<br />
		# 类别完全相同，停止划分<br />
		return classList[0]<br />
	if len(dataSet[0]) == 1:<br />
		# 遍历完所有特征时返回出现次数最多的<br />
		return majorityCnt(classList)<br />
	bestFeat = chooseBestFeatureToSplit(dataSet)<br />
	bestFeatLabel = labels[bestFeat]<br />
	myTree = {bestFeatLabel:{}}<br />
	del(labels[bestFeat])<br />
	# 得到列表包括节点所有的属性值<br />
	featValues = [example[bestFeat] for example in dataSet]<br />
	uniqueVals = set(featValues)<br />
	for value in uniqueVals:<br />
		subLabels = labels[:]<br />
		myTree[bestFeatLabel][value] = createTree(splitDataSet(dataSet, bestFeat, value), subLabels)<br />
	return myTree

def classify(inputTree, featLabels, testVec):<br />
	&quot;&quot;&quot;<br />
	输入：决策树，分类标签，测试数据<br />
	输出：决策结果<br />
	描述：跑决策树<br />
	&quot;&quot;&quot;<br />
	firstStr = list(inputTree.keys())[0]<br />
	secondDict = inputTree[firstStr]<br />
	featIndex = featLabels.index(firstStr)<br />
	classLabel = 'N'<br />
	for key in secondDict.keys():<br />
		if testVec[featIndex] == key:<br />
			if type(secondDict[key]).__name__ == 'dict':<br />
				classLabel = classify(secondDict[key], featLabels, testVec)<br />
			else:<br />
				classLabel = secondDict[key]<br />
	return classLabel

def classifyAll(inputTree, featLabels, testDataSet):<br />
	&quot;&quot;&quot;<br />
	输入：决策树，分类标签，测试数据集<br />
	输出：决策结果<br />
	描述：跑决策树<br />
	&quot;&quot;&quot;<br />
	classLabelAll = []<br />
	for testVec in testDataSet:<br />
		classLabelAll.append(classify(inputTree, featLabels, testVec))<br />
	return classLabelAll

def storeTree(inputTree, filename):<br />
	&quot;&quot;&quot;<br />
	输入：决策树，保存文件路径<br />
	输出：<br />
	描述：保存决策树到文件<br />
	&quot;&quot;&quot;<br />
	import pickle<br />
	fw = open(filename, 'wb')<br />
	pickle.dump(inputTree, fw)<br />
	fw.close()

def grabTree(filename):<br />
	&quot;&quot;&quot;<br />
	输入：文件路径名<br />
	输出：决策树<br />
	描述：从文件读取决策树<br />
	&quot;&quot;&quot;<br />
	import pickle<br />
	fr = open(filename, 'rb')<br />
	return pickle.load(fr)

def createDataSet():<br />
	&quot;&quot;&quot;<br />
	outlook-&gt;  0: sunny | 1: overcast | 2: rain<br />
	temperature-&gt; 0: hot | 1: mild | 2: cool<br />
	humidity-&gt; 0: high | 1: normal<br />
	windy-&gt; 0: false | 1: true<br />
	&quot;&quot;&quot;<br />
	dataSet = [[0, 0, 0, 0, 'N'],<br />
			   [0, 0, 0, 1, 'N'],<br />
			   [1, 0, 0, 0, 'Y'],<br />
			   [2, 1, 0, 0, 'Y'],<br />
			   [2, 2, 1, 0, 'Y'],<br />
			   [2, 2, 1, 1, 'N'],<br />
			   [1, 2, 1, 1, 'Y']]<br />
	labels = ['outlook', 'temperature', 'humidity', 'windy']<br />
	return dataSet, labels

def createTestSet():<br />
	&quot;&quot;&quot;<br />
	outlook-&gt;  0: sunny | 1: overcast | 2: rain<br />
	temperature-&gt; 0: hot | 1: mild | 2: cool<br />
	humidity-&gt; 0: high | 1: normal<br />
	windy-&gt; 0: false | 1: true<br />
	&quot;&quot;&quot;<br />
	testSet = [[0, 1, 0, 0],<br />
			   [0, 2, 1, 0],<br />
			   [2, 1, 1, 0],<br />
			   [0, 1, 1, 1],<br />
			   [1, 1, 0, 1],<br />
			   [1, 0, 1, 0],<br />
			   [2, 1, 0, 1]]<br />
	return testSet

def main():<br />
	dataSet, labels = createDataSet()<br />
	labels_tmp = labels[:] # 拷贝，createTree会改变labels<br />
	desicionTree = createTree(dataSet, labels_tmp)<br />
	#storeTree(desicionTree, 'classifierStorage.txt')<br />
	#desicionTree = grabTree('classifierStorage.txt')<br />
	print('desicionTree:\n', desicionTree)<br />
	treePlotter.createPlot(desicionTree)<br />
	testSet = createTestSet()<br />
	print('classifyResult:\n', classifyAll(desicionTree, labels, testSet))

if __name__ == '__main__':<br />
	main()<br />
</code></pre>
<h2>输出样例</h2>
<pre class="prettyprint linenums"><code>desicionTree:<br />
 {'outlook': {0: 'N', 1: 'Y', 2: {'windy': {0: 'Y', 1: 'N'}}}}<br />
classifyResult:<br />
 ['N', 'N', 'Y', 'N', 'Y', 'Y', 'N']<br />
</code></pre>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/701997/201602/701997-20160203181237225-1060579590.jpg"></p>
<h2>附加文件</h2>
<p>treePlotter.py</p>
<p>需要配置matplotlib才能使用</p>
<pre class="prettyprint linenums"><code>import matplotlib.pyplot as plt

decisionNode = dict(boxstyle=&quot;sawtooth&quot;, fc=&quot;0.8&quot;)<br />
leafNode = dict(boxstyle=&quot;round4&quot;, fc=&quot;0.8&quot;)<br />
arrow_args = dict(arrowstyle=&quot;&lt;-&quot;)

def plotNode(nodeTxt, centerPt, parentPt, nodeType):<br />
	createPlot.ax1.annotate(nodeTxt, xy=parentPt, xycoords='axes fraction', \<br />
							xytext=centerPt, textcoords='axes fraction', \<br />
							va=&quot;center&quot;, ha=&quot;center&quot;, bbox=nodeType, arrowprops=arrow_args)

def getNumLeafs(myTree):<br />
	numLeafs = 0<br />
	firstStr = list(myTree.keys())[0]<br />
	secondDict = myTree[firstStr]<br />
	for key in secondDict.keys():<br />
		if type(secondDict[key]).__name__ == 'dict':<br />
			numLeafs += getNumLeafs(secondDict[key])<br />
		else:<br />
			numLeafs += 1<br />
	return numLeafs

def getTreeDepth(myTree):<br />
	maxDepth = 0<br />
	firstStr = list(myTree.keys())[0]<br />
	secondDict = myTree[firstStr]<br />
	for key in secondDict.keys():<br />
		if type(secondDict[key]).__name__ == 'dict':<br />
			thisDepth = getTreeDepth(secondDict[key]) + 1<br />
		else:<br />
			thisDepth = 1<br />
		if thisDepth &gt; maxDepth:<br />
			maxDepth = thisDepth<br />
	return maxDepth

def plotMidText(cntrPt, parentPt, txtString):<br />
	xMid = (parentPt[0] - cntrPt[0]) / 2.0 + cntrPt[0]<br />
	yMid = (parentPt[1] - cntrPt[1]) / 2.0 + cntrPt[1]<br />
	createPlot.ax1.text(xMid, yMid, txtString)

def plotTree(myTree, parentPt, nodeTxt):<br />
	numLeafs = getNumLeafs(myTree)<br />
	depth = getTreeDepth(myTree)<br />
	firstStr = list(myTree.keys())[0]<br />
	cntrPt = (plotTree.xOff + (1.0 + float(numLeafs)) / 2.0 / plotTree.totalw, plotTree.yOff)<br />
	plotMidText(cntrPt, parentPt, nodeTxt)<br />
	plotNode(firstStr, cntrPt, parentPt, decisionNode)<br />
	secondDict = myTree[firstStr]<br />
	plotTree.yOff = plotTree.yOff - 1.0 / plotTree.totalD<br />
	for key in secondDict.keys():<br />
		if type(secondDict[key]).__name__ == 'dict':<br />
			plotTree(secondDict[key], cntrPt, str(key))<br />
		else:<br />
			plotTree.xOff = plotTree.xOff + 1.0 / plotTree.totalw<br />
			plotNode(secondDict[key], (plotTree.xOff, plotTree.yOff), cntrPt, leafNode)<br />
			plotMidText((plotTree.xOff, plotTree.yOff), cntrPt, str(key))<br />
	plotTree.yOff = plotTree.yOff + 1.0 / plotTree.totalD

def createPlot(inTree):<br />
	fig = plt.figure(1, facecolor='white')<br />
	fig.clf()<br />
	axprops = dict(xticks=[], yticks=[])<br />
	createPlot.ax1 = plt.subplot(111, frameon=False, **axprops)<br />
	plotTree.totalw = float(getNumLeafs(inTree))<br />
	plotTree.totalD = float(getTreeDepth(inTree))<br />
	plotTree.xOff = -0.5 / plotTree.totalw<br />
	plotTree.yOff = 1.0<br />
	plotTree(inTree, (0.5, 1.0), '')<br />
	plt.show()<br />
</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqv1jr1q.html">Mac&amp;&num;160&semi;下locate命令使用问题WARNING&colon; The locate database &lpar;&sol;var&sol;db&sol;locate&period;database&rpar; does not exist&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwlx0k9.html">zookeeper原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g61yzq.html">python基础&mdash;&mdash;模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e6ygkq.html">并发用户数与 TPS 之间的关系</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmo2rk9.html">Spring&lowbar;MVC&lowbar;教程&lowbar;快速入门&lowbar;深入分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/90verw48.html">代码片段--Makefile之大型工程项目子目录Makefile的一种通用写法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm42369.html">高性能ORM框架XLinq功能详细介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz1x0l8.html">Dev的GridView中如何自动生成行号</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkl60d8.html">关于安卓HTTP请求用HttpUrlConnection还是HttpClient好</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdmr0z9.html">MVC3 Razor 根据不同页面使用不同Layout</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv17n6yq.html">PredictionIO&plus;Universal Recommender快速开发部署推荐引擎的问题总结&lpar;2&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk0g3z8.html">ESP8266清理flash学习记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jm1y3q.html">-如何存储并定时更新access&lowbar;token</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwezgy8.html">【BZOJ4738&sol;UOJ&num;276】汽水（点分治，分数规划）</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wz7enq.html">解决vi编辑器不能使用方向键和退格键</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w0050q.html">【排序算法】冒泡排序&lpar;Bubble Sort&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlk6or9.html">Docker&lpar;五&rpar;-Dcoker容器</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pn3x3q.html">U-Boot&lowbar;bmp&lowbar;logo&lowbar;hacking</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjy26r8.html">Media change&colon; please insert the disc labeled</a>
		</li>
						<li><a href="https://www.batexi.com/a/93p3dz08.html">Java方法的参数传递方式为&colon; 值传递</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/90v2rv48.html">IRS-P6数据介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/96o30g39.html">C&num;导出</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydvy7mq.html">WP8&lowbar;ListBox的用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdnnyr8.html">安装node&lowbar;modules文件遇到的问题：更改代理</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zvvyz9.html">在xargx命令中如何使用重定向</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7meej1q.html">QQ聊天信息提取</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1om669.html">Nginx 开启 path&lowbar;info功能</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1o5y79.html">Windows2003屏蔽IP</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1n53k8.html">安装CMS遇到php5&period;3的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1ng0j8.html">shopnc二次开发（一）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
